#include "addr.h"
#include "net.h"
#include "def.h"
#include "util.h"
#include "string.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern bool         addr_null     (addr_t const *addr);
extern bool         addr_equal    (addr_t const *a,addr_t const *b);

bool addr_valid(addr_t *addr){
  return port_valid(addr->port);
}

bool addr_from_at(addr_t *addr,char const *at){
  char  ata[AT_BUF];
  char *atb;
  char *sep;
  int   i;

  strzcpy(ata,at,sizeof(ata));

  sep   = strchr(ata,':');
  if(!sep) return 0;
  *sep  = 0;
  atb   = sep+1;

  //TODO: non retard this
  if(!str_valid(ata,1,IPV4_LEN,IPV4_CHARSET)) return 0;
  if(!str_valid(atb,1,PORT_LEN,PORT_CHARSET)) return 0;

  if(!*ata) return 0;
  if(!*atb) return 0;

  if(!ip_u32(&addr->ip,ata)) return 0;
  i = strtoll(atb,0,10);
  if(!port_valid(i)) return 0;
  addr->port = i;
  assert(addr_valid(addr)); 

  return 1;
}

void at_from_addr(char *at,size_t at_size,addr_t const *addr){
  char ip[IPV4_BUF]; 
  ip_str(ip,sizeof(ip),addr->ip);
  snprintf(at,at_size,"%s:%u",ip,addr->port);
}

