#include "pest.h"
#include "packet.h"
#include "peer.h"
#include "log.h"
#include "time.h"
#include "util.h"
#include "utf8.h"
#include "state.h"
#include <string.h>
#include <assert.h>

void banner_handle(peer_t *p,uint8_t const *m){
  char banner[BANNER_BUF];

  //TODO: vat do vith this
  cpy_text(banner,sizeof(banner),m);

  if(!utf8_valid(banner)){
    log_err("banner from peer '%s' contains invalid UTF-8 sequence",
            p->handle[0]);
    return;
  }

  if(strcmp(banner,p->banner) != 0){
    peer_banner_set(p,banner);
  }
}

void banner_broadcast(uint64_t time){
  uint64_t        stamp;
  char const     *text;
  size_t          text_len;

  if(time < banner_last+baint) return;

  if(banner_last != 0){
    stamp     = mono_sec();
    text      = *banner ? banner : PROG_FULLERNAME;
    text_len  = strlen(text);
    send_text(CMD_BANNER,stamp,(uint8_t const *)text,text_len,0,0);
  }

  banner_last = time;
}

