#include "packet.h"
#include "pest.h"
#include "crypto.h"
#include <string.h>

void black_ciph(uint8_t *b,uint8_t const *r,uint8_t const *key_serp){
  serpent_cbc_ciph(key_serp,b+RED_OFF,r,RED_SIZE);
}

void black_deciph(uint8_t *r,uint8_t const *b,uint8_t const *key_serp){
  serpent_cbc_deciph(key_serp,r,b+RED_OFF,RED_SIZE);
}

void black_sign(uint8_t *b,uint8_t const *key){
  hmac_sha384(b+SIGN_OFF,key,KEY_SIGN_SIZE,b+RED_OFF,RED_SIZE);
}

bool black_verify(uint8_t const *b,uint8_t const *key){
  uint8_t sign[SIGN_SIZE];
  hmac_sha384(sign,key,KEY_SIGN_SIZE,b+RED_OFF,RED_SIZE);
  return memcmp(sign,b+SIGN_OFF,SIGN_SIZE) == 0;
}

