#ifndef CHAIN_H
#define CHAIN_H

#include "type.h"

void                mess_init     (mess_t *c);
void                mess_path     (mess_t *c,char const *path);
bool                mess_load     (mess_t *c);

bool                mess_push     (mess_t *c,hash_t const hash,uint8_t const *m);
unsigned            mess_lookup   (mess_t *c,hash_t const hash,uint8_t       *m);

bool                idx_cnt       (mess_t *c,size_t *idx_cnt_out);
bool                idx_ecnt      (mess_t *c,size_t *ecnt_out);
bool                idx_ins       (mess_t *c,hash_t const hash,uint64_t  index);
unsigned            idx_lookup    (mess_t *c,hash_t const hash,uint64_t *index);

bool                msg_cnt       (mess_t *c,size_t *msg_cnt_out);
bool                msg_ecnt      (mess_t *c,size_t *ecnt_out);
size_t              msg_count     (mess_t const *c);
bool                msg_ins       (mess_t *c,uint8_t const *m,uint64_t *index);
bool                msg_get       (mess_t *c,uint8_t       *m,uint64_t  index);

void                chain_init    (chain_t *c);
void                chain_path    (chain_t *c,char const *path);
bool                chain_load    (chain_t *c);

bool                chain_push    (chain_t *c,hash_t const hash,hash_t const prev);
unsigned            chain_lookup  (chain_t *c,hash_t const hash,hash_t prev);
bool                chain_resolve (chain_t *c,hash_t const head,hash_t tail);

void                ht_init       (ht_t *ht);
void                ht_path       (ht_t *ht,char const *path);
bool                ht_store      (ht_t *ht);
bool                ht_load       (ht_t *ht);

hash_t             *ht_lookup     (ht_t *ht,hash_t const hash);
hash_t             *ht_last       (ht_t *ht);
bool                ht_full       (ht_t *ht);

hash_t             *ht_add        (ht_t *ht,hash_t const hash);
void                ht_del        (ht_t *ht,hash_t *h);
void                ht_set        (ht_t *ht,hash_t *h,hash_t const hash);
void                ht_clear      (ht_t *ht,hash_t const hash);

bool                ht_null       (ht_t *h,ht_t *t);
size_t              ht_forks      (ht_t *h,ht_t *t);
size_t              ht_breaks     (ht_t *h,ht_t *t);

#endif

