#include "pest.h"
#include "irc.h"
#include "time.h"
#include "serial.h"
#include "log.h"
#include "def.h"
#include "util.h"
#include "string.h"
#include "utf8.h"
#include "config.h"
#include "state.h"

#define TEXT_STAMP_BUF      256

void console_send(peer_t         *p,
                  peer_t         *chan,
                  char const     *speaker,
                  uint8_t const  *m,
                  bool            stampold){

  char      text[TEXT_STAMP_BUF+TEXT_BUF];
  char     *text_end  = text+sizeof(text);
  char     *t         = text;
  uint64_t  stamp;
  uint64_t *con;

  con = chan ? &chan->con_stamp : &con_stamp;
  read_u64(m+TIMESTAMP_OFF,&stamp);

  if(stampold && stamp < *con){
    char const *fmt = *con-stamp < SEC_DAY ?
                      GETDATA_STAMP_FMT     " " :
                      GETDATA_OLDSTAMP_FMT  " ";
    t += time_str(t,text_end-t,fmt,stamp);
  }

  cpy_text(t,text_end-t,m);

  //put error but send message anyway
  if(!utf8_valid(t)){
    irclog_err("message from peer '%s' contains invalid UTF-8 sequence",
               p->handle[0]);
  }

  if(chan){
    //direct message
    irc_privmsg(speaker,text,self_handle);
  }else if(irc_joined){
    //broadcast
    irc_privmsg(speaker,text,irc_chan);
  }

  if(!stampold){
    *con = stamp;
  }
}

void console_stamp(peer_t *p,uint64_t stamp){
  uint64_t *con;

  con   = p ? &p->con_stamp : &con_stamp;
  *con  = stamp;
}

