#include "crypto.h"
#include "util.h"
#include <stdio.h>

#define HASH_LOG_SIZE         LOG_HASH_BYTES

extern void         hash_data     (hash_t h,void const *data,size_t size);
extern void         hash_zero     (hash_t h);
extern void         hash_copy     (hash_t dst,hash_t const src);
extern bool         hash_equal    (hash_t const a,hash_t const b);
extern bool         hash_null     (hash_t const h);

static void fmt_hex_rev(char           *buf,
                        size_t          buf_size,
                        uint8_t const  *data,
                        size_t          data_size){

  for(size_t x = data_size-1;x < (size_t)-1;x--){
    size_t n;
    n         = snprintf(buf,buf_size,"%02X",data[x]);
    buf      += n;
    buf_size -= n;
    if(buf_size == 0) return;
  }
}

void hash_str(char *buf,size_t buf_size,hash_t const hash){
  fmt_hex_rev(buf,buf_size,hash,HASH_SIZE);
}

void hash_str_log(char *buf,size_t buf_size,hash_t const hash){
  assert(HASH_LOG_SIZE <= HASH_SIZE);
  fmt_hex_rev(buf,buf_size,hash,HASH_LOG_SIZE);
}

