#include "pest.h"
#include "packet.h"
#include "crypto.h"
#include "time.h"
#include "config.h"
#include "state.h"
#include <assert.h>

bool ignore_send(peer_t *chan,pkey_t *pk){
  uint8_t text[TEXT_SIZE];
  if(!rng_read(rng_fast_fd,text,sizeof(text))) return 0;
  return send_text(CMD_IGNORE,mono_sec(),text,sizeof(text),chan,pk);
}

void ignore_broadcast(uint64_t ntime){
  uint64_t next;

  if(ntime < ignore_next) return;
  if(ignore_next > 0){
    ignore_send(0,0);
  }
  if(!rng_read(rng_fast_fd,&next,sizeof(next))) return;
  next         %= igint*NSEC_MSEC*2;
  ignore_next   = ntime+next;
}

