#include "log.h"
#include "crypto.h"
#include "def.h"
#include "ircd.h"
#include "string.h"
#include "state.h"
#include <stdbool.h>
#include <string.h>
#include <stdio.h>

static void _irc_vnotice(char const  *chan,
                         char const  *pre,
                         char const  *fmt,
                         va_list      args){

  char    buf[IRC_MSG_BUF];
  char   *b = buf;
  char   *e = buf+sizeof(buf);

  if(!irc_ready) return;

  if(!chan){
    chan = irc_chan;
    if(!*chan) chan = self_handle;
  }

  b += snprintf(b,e-b,":%s NOTICE %s :%s",IRC_SERV,chan,pre);
  b += vsnprintf(b,e-b,fmt,args);
  b  = strpcpy(b,"\r\n",e);
  ircd_send(buf,b-buf);
  memset_ffs(buf,0x00,b-buf);
}

void irc_out(char const *fmt,...){
  va_list args;
  va_start(args,fmt);
  _irc_vnotice(irc_log_chan,"",fmt,args);
  va_end(args);
}

void irc_err(char const *fmt,...){
  va_list args;
  va_start(args,fmt);
  _irc_vnotice(irc_log_chan,"error: ",fmt,args);
  va_end(args);
}

void irclog_out(char const *fmt,...){
  va_list args;
  va_list args2;
  va_start(args,fmt);
  va_copy(args2,args);
  log_vout(fmt,args);
  _irc_vnotice(irc_log_chan,"",fmt,args2);
  va_end(args);
  va_end(args2);
}

void irclog_err(char const *fmt,...){
  va_list args;
  va_list args2;
  va_start(args,fmt);
  va_copy(args2,args);
  log_verr(fmt,args);
  _irc_vnotice(irc_log_chan,"error: ",fmt,args2);
  va_end(args);
  va_end(args2);
}

//cunt
void irclog_out_chan(char const *chan,char const *fmt,...){
  va_list args;
  va_list args2;
  va_start(args,fmt);
  va_copy(args2,args);
  log_vout(fmt,args);
  _irc_vnotice(chan,"",fmt,args2);
  va_end(args);
  va_end(args2);
}

//cunt
void irclog_err_chan(char const *chan,char const *fmt,...){
  va_list args;
  va_list args2;
  va_start(args,fmt);
  va_copy(args2,args);
  log_verr(fmt,args);
  _irc_vnotice(chan,"error: ",fmt,args2);
  va_end(args);
  va_end(args2);
}

