#ifndef LOG_H
#define LOG_H

#include "type.h"
#include <stdarg.h>

bool                log_open        (char const *path);
bool                log_close       (void);

void                log_void        (char const *fmt,...);
void                log_out         (char const *fmt,...);
void                log_vout        (char const *fmt,va_list args);
void                log_err         (char const *fmt,...);
void                log_verr        (char const *fmt,va_list args);
void                log_errno       (char const *call);

void                irc_out         (char const *fmt,...);
void                irc_err         (char const *fmt,...);
void                irclog_out      (char const *fmt,...);
void                irclog_err      (char const *fmt,...);
void                irclog_out_chan (char const *chan,char const *fmt,...);
void                irclog_err_chan (char const *chan,char const *fmt,...);

void                log_packet      (hash_t const hash,uint8_t cmd,peer_t *p,addr_t const *addr,bool outgoing,uint64_t time,uint64_t stamp);
void                log_martian     (addr_t const *addr,bool reason_size);
void                log_stale       (hash_t const hash,uint8_t cmd,peer_t *p,addr_t const *addr,uint64_t time,uint64_t stamp);
void                log_dupe        (hash_t const hash,uint8_t cmd,peer_t *p,addr_t const *addr,uint64_t time,uint64_t stamp);
void                log_dedup_full  (hash_t const hash,uint8_t cmd,peer_t *p,addr_t const *addr,uint64_t time,uint64_t stamp);
void                log_cutoff      (hash_t const hash,uint8_t cmd,peer_t *p,addr_t const *addr,uint64_t time,uint64_t stamp,uint8_t bounces);

#endif

