//okesoft illegal to look at gode license
//this file is illegal to look at btw. do NOT look at the gode in this file
//u can look at the other files they are covered under difrent license

#include "pest.h"
#include "peer.h"
#include "chain.h"
#include "packet.h"
#include "crypto.h"
#include "log.h"
#include "util.h"
#include "state.h"

static void problems_display(peer_t      *p,
                             peer_t      *chan,
                             char const  *speaker){

  char const     *handle  = p->handle[0];
  char const     *chname  = chan ? "direct message"  : "broadcast";
  char const     *ichan   = chan ? speaker           : irc_chan;
  ht_t           *head    = chan ? &p->dhead         : &p->bhead;
  ht_t           *tail    = chan ? &p->dtail         : &p->btail;

  size_t f = ht_forks  (head,tail);
  size_t b = ht_breaks (head,tail);

  if(f == 0 && b == 0) return;
  irclog_out_chan(ichan,
                  "peer '%s' %s chain has %zu fork%s and %zu break%s",
                  handle,chname,
                  f,f == 1 ? "" : "s",
                  b,b == 1 ? "" : "s");
}

static void message_display(mess_t         *ms,
                            chain_t        *ch,
                            peer_t         *p,
                            peer_t         *chan,
                            uint8_t const  *m,
                            hash_t const    hash,
                            char const     *speaker,
                            bool            stampold){

  if(ch) chain_push(ch,hash,m+SELFCHAIN_OFF);
  if(ms){
    if(mess_lookup(ms,hash,0) != LOOKUP_NOTFOUND){
      //eror or mesage already shown to operator at some point
      return;
    }
    mess_push(ms,hash,m);
    if(p){
      problems_display(p,chan,speaker);
    }
    console_send(p,chan,speaker,m,stampold);
  }
}

//TODO: this gode is udderly ridiculous FIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIX
void message_handle(uint8_t const  *m,
                    hash_t const    hash,
                    char const     *speaker,
                    peer_t         *p,
                    peer_t         *chan,
                    bool            stampold,
                    bool            pend,
                    bool            display){

  mess_t         *ms      = chan ? &p->mess          : &mess;
  chain_t        *ch      = chan ? &p->dchain        : &p->bchain;
  ht_t           *head    = chan ? &p->dhead         : &p->bhead;
  ht_t           *tail    = chan ? &p->dtail         : &p->btail;
  char const     *chname  = chan ? "direct message"  : "broadcast";
  char const     *ichan   = chan ? speaker           : irc_chan;
  mess_t         *mms     = display ? ms : 0;
  uint8_t const  *prev    = m+SELFCHAIN_OFF;
  char const     *handle  = p->handle[0];
  hash_t         *h;
  hash_t         *t;
  unsigned        r; 
  uint8_t         m_prev[MESSAGE_SIZE];

  getdata_del(hash,0);

again:
  if(h = ht_lookup(head,prev)){
    //continuation in > dir of existing head, common case
    if(ht_null(head,tail) && hash_null(prev)){
      irclog_out_chan(ichan,"peer '%s' met! (%s)",
                      handle,chname);
    }

    //see if this merges something
    if(t = ht_lookup(tail,hash)){
      ht_del(head,h);
      ht_del(tail,t);
      irclog_out_chan(ichan,"peer '%s' %s chain break repaired",
                      handle,chname);
    }else{
      ht_set(head,h,hash);
    }

    message_display(mms,ch,p,chan,m,hash,speaker,stampold);

    //see if this fixed pending problems
    if(pend) pending_send_chain(hash);

  }else if(((r = LOOKUP_FOUND) && ht_lookup(tail,prev)) || //this gode is tmp
           (r = chain_lookup(ch,prev,0)) == LOOKUP_FOUND){

    if(r == LOOKUP_IO) return;
    
    switch(chain_lookup(ch,hash,0)){
    case LOOKUP_FOUND:
      //dupe.. shud never hapen but... ????????
      //throw away mesage i gues
    case LOOKUP_IO:
      return;

    case LOOKUP_NOTFOUND:
      break;
    }

    //new fork city

    if(ht_full(head)){
      irc_err("head buffer full for peer '%s'",handle);
      return;
    }else{
      h = ht_add(head,hash);
    }

    //see if this merges something
    if(t = ht_lookup(tail,hash)){
      ht_del(head,h);
      ht_del(tail,t);
      irclog_out_chan(ichan,"peer '%s' %s chain break repaired",
                      handle,chname);
    }

    irclog_out_chan(ichan,"peer '%s' %s chain forked!",
                    handle,chname);
    message_display(mms,ch,p,chan,m,hash,speaker,stampold);

    //see if this "fixed" pending problems
    if(pend) pending_send_chain(hash);

  }else if((r = mess_lookup(ms,prev,m_prev)) != LOOKUP_NOTFOUND){
    if(r == LOOKUP_IO) return;
    //TODO: fix total retart gode
    message_handle(m_prev,prev,speaker,p,chan,stampold,0,0);
    goto again; //retard

  }else if(pend){
    //new break or continuation in < or > dir of existing pending break
    if(pending_dontfull()) goto again; //retard
    pending_push(m,hash,speaker,p,chan);

  }else if(t = ht_lookup(tail,hash)){
    //continuation in < dir of existing break/valid chain
    ht_set(tail,t,prev);

    message_display(mms,ch,p,chan,m,hash,speaker,1);
    getdata_push_cond(p,chan,prev);

  }else{
    //new break, dont add to pending table
    if(ht_full(head) || ht_full(tail)){
      irc_err("head/tail buffer full for peer '%s'",handle);
      return;
    }

    ht_add(head,hash);
    ht_add(tail,prev);

    irclog_out_chan(ichan,"peer '%s' %s chain broken!",
                    handle,chname);
    message_display(mms,ch,p,chan,m,hash,speaker,stampold);
    getdata_push_cond(p,chan,prev);
  }
}

void message_handle_simp(uint8_t const *m,
                         hash_t const   hash,
                         char const    *speaker,
                         bool           stampold){

  //uint8_t    *m_self  = m+SELFCHAIN_OFF;
  //uint8_t    *m_net   = m+NETCHAIN_OFF;

  message_display(&mess,0,0,0,m,hash,speaker,stampold);
  //TODO: vtf do with responses to this? put in hearsay baffer or vat?
  //getdata_push_cond(0,0,m_self);
  //getdata_push_cond(0,0,m_net);
}

bool broadcast_handle(peer_t       *p,
                      peer_t       *gd_peer,
                      bool          immediate,
                      bool          pmaster,
                      uint8_t      *r,
                      hash_t const  hash,
                      uint8_t       bounces,
                      char const   *speaker){

  //TODO: vat a mess
  uint8_t const *m = r+MESSAGE_OFF;
  peer_t        *q;

  if(gd_peer){
    //getdata response
    message_handle(m,hash,speaker,gd_peer,0,1,1,1);
  }else if(immediate){
    //immediate message
    message_handle(m,hash,speaker,p,0,0,1,1);
    red_rebroadcast(r,hash,bounces);
  }else if(pmaster){
    //message from master, treat as "immediate"
    if(q = peer_lookup_noerr(speaker)){
      //in-wot
      message_handle(m,hash,speaker,q,0,0,1,1);
    }else{
      //out-of-wot
      message_handle_simp(m,hash,speaker,0);
    }

    bounces = 1;
    red_rebroadcast(r,hash,bounces);
  }else{
    //hearsay
    if(bounces == 0){
      irclog_err("hearsay message with 0 bounces "
                 "discarded from peer '%s'",p->handle[0]);
      return 0;
    }

    q = peer_lookup_noerr(speaker);
    hearsay_push(hash,r,q,p,bounces);
  }

  return 1;
}

bool direct_handle(peer_t        *p,
                   peer_t        *gd_peer,
                   bool           immediate,
                   uint8_t       *r,
                   hash_t const   hash,
                   uint8_t        bounces,
                   char const    *speaker){

  uint8_t const  *m = r+MESSAGE_OFF;
  char            speaker_ext[HANDLE_EXT_BUF];
  char const     *speaker_ptr;

  if(bounces != 0){
    irclog_err("direct message with bounces != 0 "
               "received from peer '%s'",p->handle[0]);
    return 0;
  }

  if(immediate){
    speaker_ptr = speaker;
  }else{
    fmt_handle_ext(speaker_ext,sizeof(speaker_ext),
                   speaker,p->handle,p->handle_cnt);
    speaker_ptr = speaker_ext;
  }

  message_handle(m,hash,speaker_ptr,p,p,(bool)gd_peer,1,1);
  return 1;
}

