#ifndef UDP_H
#define UDP_H

#include "type.h"
#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>

bool                ip_u32          (uint32_t *ip,char const *str);
bool                ip_str          (char *str,size_t str_size,uint32_t ip);

bool                udp_bound       (void);
size_t              udp_recv        (uint32_t *src_ip,uint16_t *src_port,uint16_t port,uint8_t *data,size_t size);
size_t              udp_send        (uint32_t ip,uint16_t port,uint8_t const *data,size_t size);

void                tcp_init        (tcpev_f func);
size_t              tcp_recv        (uint32_t *src_ip,uint16_t *src_port,uint16_t port,uint8_t *data,size_t size);
size_t              tcp_send        (uint8_t const *data,size_t size);
void                tcp_lclose      (void);
void                tcp_cclose      (void);

#endif

