#ifndef PACKET_H
#define PACKET_H

#include "data.h"
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

void                black_ciph      (uint8_t *b,uint8_t const *r,uint8_t const *key_serp);
void                black_deciph    (uint8_t *r,uint8_t const *b,uint8_t const *key_serp);
void                black_sign      (uint8_t *b,uint8_t const *key);
bool                black_verify    (uint8_t const *b,uint8_t const *key);

bool                red_rebroadcast (uint8_t *r,hash_t const hash,uint8_t bounces);

bool                send_message    (uint8_t command,uint8_t *r,hash_t hash,peer_t *chan,pkey_t *pk);
bool                send_text       (uint8_t command,uint64_t stamp,uint8_t const *text,size_t text_size,peer_t *chan,pkey_t *pk);
bool                send_ustr       (uint8_t cmd,char const *ustr,peer_t *chan);

bool                pest_recv       (uint64_t time);

#endif

