#ifndef PEER_H
#define PEER_H

#include "type.h"
#include <stdbool.h>

pkey_t             *pkey_lookup_noerr (uint8_t const *key,peer_t **peer_out);

peer_t             *peer_lookup_id          (peerid_t id);
peer_t             *peer_lookup_noerr       (char const *handle);
peer_t             *peer_lookup             (char const *handle);
pkey_t             *peer_lookup_pkey        (peer_t *p,uint8_t const *key);
peer_t             *peer_add                (char const *handle);
void                peer_del                (peer_t *p);
bool                peer_alias_add          (peer_t *p,char const *alias);
unsigned            peer_alias_del          (peer_t *p,char const *alias);
bool                peer_key_add            (peer_t *p,uint8_t const *key,bool silent);
bool                peer_key_del            (uint8_t const *key,bool silent);
void                peer_key_stamp          (peer_t *p,pkey_t *pk,uint64_t time);
pkey_t             *peer_key_recent         (peer_t *p);
bool                peer_addr_set           (peer_t *p,addr_t *addr,bool spam);
void                peer_pause              (peer_t *p,bool pause);
void                peer_stamp              (peer_t *p,uint64_t stamp);
void                peer_pak_stamp          (peer_t *p,uint64_t stamp);
void                peer_banner_set         (peer_t *p,char const *banner);
char               *peer_handle_lookup      (peer_t *p,char const *handle);
bool                peer_cansend            (peer_t *p,bool error);

peer_t             *peer_add_internal       (char const *handle,bool boot);
bool                peer_alias_add_internal (peer_t *p,char const *alias,bool boot);
bool                peer_key_add_internal   (peer_t *p,uint8_t const *key,uint64_t time,bool boot,bool silent);

void                peer_print              (peer_t *p);
void                peer_wot_print          (void);
void                peer_addr_print         (peer_t *p);
void                peer_at_print           (void);

bool                peer_alias_store        (peer_t *p);
bool                peer_key_store          (peer_t *p);
bool                peer_addr_store         (peer_t *p);
bool                peer_stamp_store        (peer_t *p);
bool                peer_pause_store        (peer_t *p);
bool                peer_banner_store       (peer_t *p);

bool                peer_loadpeer           (peer_t *p);
bool                peer_load               (void);

#endif

