#ifndef STATE_H
#define STATE_H

#include "def.h"
#include "type.h"
#include <stdint.h>
#include <stddef.h>
#include <stdio.h>

//memory state
extern char         data_path     [PATH_BUF];
extern char         self_handle   [HANDLE_BUF];
extern bool         running;
extern bool         scram;
extern uint64_t     mono_offset;
extern char         log_path      [PATH_BUF];
extern FILE        *log_fp;
extern int          rng_slow_fd;
extern int          rng_fast_fd;

extern char         irc_chan      [IRC_CHAN_BUF];
extern char         irc_host      [IRC_HOST_BUF];
extern bool         irc_conned;
extern bool         irc_usered;
extern bool         irc_passed;
extern bool         irc_nicked;
extern bool         irc_joined;
extern bool         irc_ready;
extern char const  *irc_log_chan;

extern int          udp_fd;
extern bool         udp_silent;
extern tcpev_f      tcp_func;
extern int          tcp_listen_fd;
extern int          tcp_client_fd;
extern uint32_t     tcp_client_ip;
extern uint16_t     tcp_client_port;
extern bool         tcp_silent;

extern ircev_f      ircd_func;
extern uint32_t     ircd_src_ip;
extern uint16_t     ircd_src_port;
extern char         ircd_buf      [IRC_MSG_BUF];
extern char        *ircd_buf_p;

extern uint64_t     con_stamp;
extern uint64_t     rekey_last;
extern uint64_t     ignore_next;
extern uint64_t     banner_last;
extern uint64_t     addrcast_last;

extern getdata_t    gd            [GETDATA_MAX];
extern size_t       gd_cnt;
extern uint64_t     gd_retry_last;

extern hearsay_t    hs            [HEARSAY_MAX];
extern size_t       hs_cnt;

extern pending_t    pen           [PENDING_MAX];
extern size_t       pen_cnt;

//persistent state
extern char         irc_user      [IRC_USER_BUF];
extern uint8_t      irc_pass      [PASS_SIZE];
extern uint16_t     irc_port;
extern uint16_t     pest_port;
extern uint8_t      scram_pass    [PASS_SIZE];

extern bool         setport;
extern int64_t      cutoff;
extern int64_t      hstime;
extern int64_t      gdtime;
extern int64_t      gdatt;
extern int64_t      gdint;
extern bool         rkrecv;
extern bool         rksend;
extern int64_t      rktime;
extern int64_t      rkint;
extern int64_t      igint;
extern char         banner        [BANNER_BUF];
extern int64_t      baint;
extern char         acaddr        [AT_BUF];
extern int64_t      acint;
extern int64_t      irctime;
extern char         master        [HANDLE_BUF];

extern peer_t       peer          [PEER_MAX];
extern size_t       peer_cnt;
extern peerid_t     peer_id;

extern handle_t     killfile      [KILLFILE_MAX];
extern size_t       killfile_cnt;

extern mess_t       mess;
extern hash_t       self;
extern hash_t       net;

extern hash_t       dedup_h       [DEDUP_MAX];
extern uint64_t     dedup_t       [DEDUP_MAX];
extern uintptr_t    dedup_f;
extern uintptr_t    dedup_b;

#endif

