#ifndef STRING_H
#define STRING_H

#include <stdbool.h>
#include <stddef.h>
#include <assert.h>

char               *strzcpy           (char *restrict dst,char const *restrict src,size_t dst_size);
char               *strzcpy_quote     (char *restrict dst,char const *restrict src,size_t dst_size);
inline char        *strzzcpy          (char *restrict dst,char const *restrict src,size_t dst_size,size_t src_size);
inline char        *strpcpy           (char *restrict dst,char const *restrict src,char const *restrict dst_end);
inline char        *strpzcpy          (char *restrict dst,char const *restrict src,char const *restrict dst_end,size_t src_size);
int                 strcmpci          (char const *restrict a,char const *restrict b);
int                 strncmpci         (char const *restrict a,char const *restrict b,size_t n);
char               *strchr0           (char const *s,char c);
char               *strnotchr0        (char const *s,char n);
char               *scan_white        (char const *str);
char               *scan_nowhite      (char const *str);
char               *scan_back_nowhite (char const *str,char const *p);
char               *str_nstr          (char const *s,char const *f,size_t s_len);
void                str_tolower       (char *str);
void                str_toupper       (char *str);
void                str_stripnl       (char *str);
char               *str_trim          (char *str);
size_t              str_args          (char *str,size_t argc_max,char **argv);
bool                str_valid         (char const *str,size_t min,size_t max,char const *charset);

inline char *strzzcpy(char       *restrict  dst,
                      char const *restrict  src,
                      size_t                dst_size,
                      size_t                src_size){

  if(dst_size > src_size+1) dst_size = src_size+1;
  return strzcpy(dst,src,dst_size);
}

inline char *strpcpy(char       *restrict dst,
                     char const *restrict src,
                     char const *restrict dst_end){

  assert(dst < dst_end);
  size_t dst_size = dst_end-dst;
  return strzcpy(dst,src,dst_size);
}

inline char *strpzcpy(char       *restrict  dst,
                      char const *restrict  src,
                      char const *restrict  dst_end,
                      size_t                src_size){

  assert(dst < dst_end);
  size_t dst_size = dst_end-dst;
  if(dst_size > src_size+1) dst_size = src_size+1;
  return strzcpy(dst,src,dst_size);
}

#endif

