#define _XOPEN_SOURCE 600
#include "wipe.h"
#include "crypto.h"
#include "log.h"
#include "util.h"
#include "state.h"
#include <ftw.h>
#include <unistd.h>
#include <fcntl.h>

void state_zero(void){
  //BUF_ZERO(data_path);
  BUF_ZERO(self_handle);
  VAR_ZERO(running);
  VAR_ZERO(scram);
  VAR_ZERO(mono_offset);
  //BUF_ZERO(log_path);
  VAR_ZERO(log_fp);
  VAR_ZERO(rng_slow_fd);
  //VAR_ZERO(rng_fast_fd);

  BUF_ZERO(irc_chan);
  BUF_ZERO(irc_host);
  VAR_ZERO(irc_conned);
  VAR_ZERO(irc_usered);
  VAR_ZERO(irc_passed);
  VAR_ZERO(irc_nicked);
  VAR_ZERO(irc_joined);
  VAR_ZERO(irc_ready);
  VAR_ZERO(irc_log_chan);

  VAR_ZERO(udp_fd);
  VAR_ZERO(udp_silent);
  VAR_ZERO(tcp_func);
  VAR_ZERO(tcp_listen_fd);
  VAR_ZERO(tcp_client_fd);
  VAR_ZERO(tcp_client_ip);
  VAR_ZERO(tcp_client_port);
  VAR_ZERO(tcp_silent);

  VAR_ZERO(ircd_func);
  VAR_ZERO(ircd_src_ip);
  VAR_ZERO(ircd_src_port);
  BUF_ZERO(ircd_buf);
  VAR_ZERO(ircd_buf_p);

  VAR_ZERO(con_stamp);
  VAR_ZERO(rekey_last);
  VAR_ZERO(ignore_next);
  VAR_ZERO(banner_last);
  VAR_ZERO(addrcast_last);

  BUF_ZERO(gd);
  VAR_ZERO(gd_cnt);
  VAR_ZERO(gd_retry_last);

  BUF_ZERO(hs);
  VAR_ZERO(hs_cnt);

  BUF_ZERO(pen);
  VAR_ZERO(pen_cnt);

  BUF_ZERO(irc_user);
  BUF_ZERO(irc_pass);
  VAR_ZERO(irc_port);
  VAR_ZERO(pest_port);
  BUF_ZERO(scram_pass);

  VAR_ZERO(setport);
  VAR_ZERO(cutoff);
  VAR_ZERO(hstime);
  VAR_ZERO(gdtime);
  VAR_ZERO(gdatt);
  VAR_ZERO(gdint);
  VAR_ZERO(rkrecv);
  VAR_ZERO(rksend);
  VAR_ZERO(rktime);
  VAR_ZERO(rkint);
  VAR_ZERO(igint);
  BUF_ZERO(banner);
  VAR_ZERO(baint);
  BUF_ZERO(acaddr);
  VAR_ZERO(acint);
  VAR_ZERO(irctime);
  BUF_ZERO(master);

  BUF_ZERO(peer);
  VAR_ZERO(peer_cnt);
  VAR_ZERO(peer_id);

  BUF_ZERO(killfile);
  VAR_ZERO(killfile_cnt);

  VAR_ZERO(mess);
  VAR_ZERO(self);
  VAR_ZERO(net);

  BUF_ZERO(dedup_h);
  BUF_ZERO(dedup_t);
  VAR_ZERO(dedup_f);
  VAR_ZERO(dedup_b);

  fputs("state zeroized\n",stderr);
}

void state_rand(void){
  BUF_RAND(data_path);
  BUF_RAND(self_handle);
  VAR_RAND(running);
  VAR_RAND(scram);
  VAR_RAND(mono_offset);
  BUF_RAND(log_path);
  VAR_RAND(log_fp);
  VAR_RAND(rng_slow_fd);
  //VAR_RAND(rng_fast_fd);

  BUF_RAND(irc_chan);
  BUF_RAND(irc_host);
  VAR_RAND(irc_conned);
  VAR_RAND(irc_usered);
  VAR_RAND(irc_passed);
  VAR_RAND(irc_nicked);
  VAR_RAND(irc_joined);
  VAR_RAND(irc_ready);
  VAR_RAND(irc_log_chan);

  VAR_RAND(udp_fd);
  VAR_RAND(udp_silent);
  VAR_RAND(tcp_func);
  VAR_RAND(tcp_listen_fd);
  VAR_RAND(tcp_client_fd);
  VAR_RAND(tcp_client_ip);
  VAR_RAND(tcp_client_port);
  VAR_RAND(tcp_silent);

  VAR_RAND(ircd_func);
  VAR_RAND(ircd_src_ip);
  VAR_RAND(ircd_src_port);
  BUF_RAND(ircd_buf);
  VAR_RAND(ircd_buf_p);

  VAR_RAND(con_stamp);
  VAR_RAND(rekey_last);
  VAR_RAND(ignore_next);
  VAR_RAND(banner_last);
  VAR_RAND(addrcast_last);

  BUF_RAND(gd);
  VAR_RAND(gd_cnt);
  VAR_RAND(gd_retry_last);

  BUF_RAND(hs);
  VAR_RAND(hs_cnt);

  BUF_RAND(pen);
  VAR_RAND(pen_cnt);

  BUF_RAND(irc_user);
  BUF_RAND(irc_pass);
  VAR_RAND(irc_port);
  VAR_RAND(pest_port);
  BUF_RAND(scram_pass);

  VAR_RAND(setport);
  VAR_RAND(cutoff);
  VAR_RAND(hstime);
  VAR_RAND(gdtime);
  VAR_RAND(gdatt);
  VAR_RAND(gdint);
  VAR_RAND(rkrecv);
  VAR_RAND(rksend);
  VAR_RAND(rktime);
  VAR_RAND(rkint);
  VAR_RAND(igint);
  BUF_RAND(banner);
  VAR_RAND(baint);
  BUF_RAND(acaddr);
  VAR_RAND(acint);
  VAR_RAND(irctime);
  BUF_RAND(master);

  BUF_RAND(peer);
  VAR_RAND(peer_cnt);
  VAR_RAND(peer_id);

  BUF_RAND(killfile);
  VAR_RAND(killfile_cnt);

  VAR_RAND(mess);
  VAR_RAND(self);
  VAR_RAND(net);

  BUF_RAND(dedup_h);
  BUF_RAND(dedup_t);
  VAR_RAND(dedup_f);
  VAR_RAND(dedup_b);

  fputs("state randomized\n",stderr);
}

void stack_test(void){
  uint8_t stack[STACK_WIPE_SIZE];  
  BUF_ZERO(stack);
}

void stack_zero(void){
  uint8_t stack[STACK_WIPE_SIZE];  
  BUF_ZERO(stack);
  fprintf(stderr,"stack zeroized (%d MB)\n",
          STACK_WIPE_SIZE/MEGABYTE);
}

void stack_rand(void){
  uint8_t stack[STACK_WIPE_SIZE];  
  if(BUF_RAND(stack)){
    fprintf(stderr,"stack randomized (%d MB)\n",
            STACK_WIPE_SIZE/MEGABYTE);
  }else{
    fprintf(stderr,"failed to randomize stack (%d MB)\n",
            STACK_WIPE_SIZE/MEGABYTE);
  }
}

void scram_push(void){
  running   = 0;
  scram     = 1;
  irclog_out("SCRAM ACTIVATED - WIPING STATION STATE");
}

